com.ibm.openpages.api.service

## Interface IAuditService

-     public interface IAuditService

  Service to retrieve audit logs for OpenPages objects. The supported types of audit logs are IFieldAuditLog and IAssociationAuditLog.

  - IFieldAuditLog returns the logs for field changes on the specified object.
  - IAssociationAuditLog returns the association changes performed on the specified object.

  When specifying a date range for Audit Logs using the `AuditLogFilter` the date/time stored in OpenPages for Audit information is only precise to the second. For example when a field is modified at system time '2015-11-01 12:10:24.143' the date stored in the Audit Log for the field change would be '2015-11-01 12:10:24.000'. This needs to be accounted for when passing in Start and End Date parameters to the AuditLogFilter.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.util.List<IAuditLog>` | `getAssociationAuditLog(Id id)` Retrieves a List of AssociationAuditLogs for a given GRCObject Id.
    `java.util.List<IAuditLog>` | `getAssociationAuditLog(Id id, AuditLogFilter filter)` Retrieves a list of AssociationAuditLogs for a given GRCObject Id.
    `java.util.List<IAuditLog>` | `getAuditLog(Id id)` Retrieves a list of all AuditLogs (IFieldAuditLog, IAssociationAuditLog) for a given GRCObject Id.
    `java.util.List<IAuditLog>` | `getAuditLog(Id id, AuditLogFilter filter)` Retrieves a list of all AuditLogs (IFieldAuditLog, IAssociationAuditLog) for a given GRCObject Id and AuditLogFilter.
    `java.util.List<IAuditLog>` | `getFieldAuditLog(Id id)` Retrieves a list of FieldAuditLogs for a given GRCObject Id.
    `java.util.List<IAuditLog>` | `getFieldAuditLog(Id id, AuditLogFilter filter)` Retrieves a list of FieldAuditLogs for a given GRCObject Id.

- - ### Method Detail

    - #### getAuditLog

          java.util.List<IAuditLog> getAuditLog(Id id)

      Retrieves a list of all AuditLogs (IFieldAuditLog, IAssociationAuditLog) for a given GRCObject Id.
      Parameters:
        `id` - (required) target GRCObject's Id

    - #### getAuditLog

          java.util.List<IAuditLog> getAuditLog(Id id,
                                                AuditLogFilter filter)

      Retrieves a list of all AuditLogs (IFieldAuditLog, IAssociationAuditLog) for a given GRCObject Id and AuditLogFilter. If no filter specified, then all logs are retrieved.
      Parameters:
        `id` - (required) target GRCObject's Id
        `filter` - AuditLog filter
      Returns:
        a list of association audit logs for a given Id and filter

    - #### getFieldAuditLog

          java.util.List<IAuditLog> getFieldAuditLog(Id id)

      Retrieves a list of FieldAuditLogs for a given GRCObject Id.
      Parameters:
        `id` - (required) target GRCObject's Id
      Returns:
        a list of field audit logs for a given Id.

    - #### getAssociationAuditLog

          java.util.List<IAuditLog> getAssociationAuditLog(Id id)

      Retrieves a List of AssociationAuditLogs for a given GRCObject Id.
      Parameters:
        `id` - (required) target GRCObject's Id
      Returns:
        a list of association audit logs for a given Id.

    - #### getFieldAuditLog

          java.util.List<IAuditLog> getFieldAuditLog(Id id,
                                                     AuditLogFilter filter)

      Retrieves a list of FieldAuditLogs for a given GRCObject Id. If no filter specified, then all field logs are retrieved.
      Parameters:
        `id` - (required) target GRCObject's Id
        `filter` - auditLog filter
      Returns:
        a list of field audit logs for a given Object Id and filter.

    - #### getAssociationAuditLog

          java.util.List<IAuditLog> getAssociationAuditLog(Id id,
                                                           AuditLogFilter filter)

      Retrieves a list of AssociationAuditLogs for a given GRCObject Id. If no filter specified, then all association logs are retrieved.
      Parameters:
        `id` - (required) target GRCObject's Id
        `filter` - auditLog filter
      Returns:
        a list of association audit logs for a given Object Id and filter.

Licensed Materials - Property of IBM
OpenPages with Watson (PID: 5725-D51)
© Copyright IBM Corporation 2013, 2021. All Rights Reserved.
US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.